datablock ParticleData(FuryEngineParticle)
{
  dragCoefficient = 2;
  gravityCoefficient = -1;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 10;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.8 0.8 0.8 0.3";
  colors[1] = "0.8 0.8 0.8 0";
  sizes[0] = 0.3;
  sizes[1] = 0.2;
  useInvAlpha = true;
};

datablock ParticleEmitterData(FuryEngineEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 4;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 20;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "FuryEngineParticle";
  useEmitterColors = true;
};

datablock ShapeBaseImageData(FuryEngineImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 9;

  stateName[0] = "Smoke";
  stateTransitionOnTimeout[0] = "Smoke";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 1000;
  stateEmitter[0] = FuryEngineEmitter;
  stateEmitterTime[0] = 1000;
};

datablock WheeledVehicleData(FuryVehicle)
{
	isCustom=1;
	type="Fury";
	
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./Fury.dts"; //"~/data/shapes/skivehicle.dts"; //
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 4;
   mountThread[0] = "sit";
   mountThread[1] = "sit";
   mountThread[2] = "sit";
   mountThread[3] = "sit";

   //mountThread[4] = "sit";
   //mountThread[5] = "root";
   //mountThread[6] = "root";
   //mountThread[7] = "sit";

	maxDamage = 200.00;
	destroyedLevel = 200.00;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 -0.5 1";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 10;         // Far distance from vehicle
	cameraOffset = 5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	defaultTire	= FuryTire;
	defaultSpring	= FurySpring;
	//flatTire	= FuryFlatTire;
	//flatSpring	= FuryFlatSpring;

   numWheels = 4;

	// Rigid Body
	mass = 300;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 12000; //4000;       // Engine power
	engineBrake = 500;         // Braking when throttle is 0
	brakeTorque = 2000;        // When brakes are applied
	maxWheelSpeed = 50;        // Engine scale by current speed / max speed

	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0.1;

   // Advanced Steering
   steeringAutoReturn = true;
   steeringAutoReturnRate = 0.9;
   steeringAutoReturnMaxSpeed = 10;
   steeringUseStrafeSteering = true;
   steeringStrafeSteeringRate = 0.1;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "Fury";
	rideable = true;
		lookUpLimit = 0.5;
		lookDownLimit = 0.5;

	paintable = true;
   
   damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;
	
    handsOnVehicle = 1;

   numDmgEmitterAreas = 1;

   initialExplosionProjectile = FuryExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 4000;

   finalExplosionProjectile = FuryFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now

   minRunOverSpeed    = 4;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 8;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed

   //protection for passengers
   protectPassengersBurn   = false;  //protect passengers from the burning effect of explosions?
   protectPassengersRadius = true;  //protect passengers from radius damage (explosions) ?
   protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?
};
Garage_AddParts("add-ons/Vehicle_Fury/Fury.txt");

function FuryVehicle::onAdd(%this,%obj)
{
	parent::onadd(%this,%obj);
	%obj.setWheelTire(0, FuryFrontTire);
	%obj.setWheelTire(1, FuryFrontTire);
	%obj.setWheelTire(2, FuryTire);
	%obj.setWheelTire(3, FuryTire);

	%obj.setWheelSpring(0, Furyspring);
	%obj.setWheelSpring(1, Furyspring);
	%obj.setWheelSpring(2, Furyspring);
	%obj.setWheelSpring(3, Furyspring);

	%obj.setWheelPowered(0, false );
	%obj.setWheelPowered(1, false );
	%obj.setWheelPowered(2, true );
	%obj.setWheelPowered(3, true );
	
	%obj.setWheelSteering(0,1);
	%obj.setWheelSteering(1,1);
	%obj.setWheelSteering(2,0);
	%obj.setWheelSteering(3,0);
	%obj.schedule(0,garageDefault);
	%obj.mountable = true;

  FuryEngineCheck(%obj);
  
  %obj.hideNode(lightsON);
	%obj.hideNode(brakeOFFLIGHT);
	
	%obj.hideNode(lhand);
	%obj.hideNode(rhand);
	%obj.hideNode(lhook);
	%obj.hideNode(rhook);
}

function FuryEngineCheck(%obj)
{
  if(!isObject(%obj)) return;
  if(!isObject(%obj.getMountNodeObject(0))) %obj.unMountImage(3);
  else
    %obj.mountImage(FuryEngineImage,3);
  Schedule(2000,0,"FuryEngineCheck",%obj);
}

package FuryLights
{
	function serverCmdLight(%client)
	{	
		if(isObject(%client.player) && !isObject(%client.player.light))
		{
			%player = %client.Player;
			%coach = %player.getControlObject();

			if(isObject(%coach))
				if(%coach.getDatablock() == FuryVehicle.getID())
				{
				if(%coach.door == 0)
					{
						%coach.door = 1;
						%coach.hidenode(lightsOFF);
						%coach.unhidenode(lightsON);
						%coach.unhidenode(brakeOFFLIGHT);
						%coach.hidenode(brakeOFF);
					}
					else
					{
						%coach.door = 0;
						%coach.hidenode(lightsON);
						%coach.unhidenode(lightsOFF);
						%coach.hidenode(brakeOFFLIGHT);
						%coach.unhidenode(brakeOFF);
					}
					return;
				}
		}
		parent::serverCmdLight(%client);
	}
};
activatePackage(FuryLights);